

//Based on Tom Igoe Tone Example.

//Base 0 uses pin 13, pin12, and pin 11
//Base 1 uses pin 10, pin9, and pin 8
//Base 2 uses pin 7, pin6, and pin 5
#include "pitches.h"

using namespace std;

int val1=0;
int val2=0;
int val3=0;
int val4=0;
int val5=0;
int val6=0;
int val7=0;
int val8=0;
int val9=0;
int val10=0;
int val11=0;
int val12=0;


class song {
  public:
  song() {}
  byte durations[16];
  int notes[16];
  int numNotes;
  

  void init (byte d[], int n[], int size) { 
    numNotes = size;
    for (int i = 0; i < numNotes ; i++) {
       durations[i] = d[i];
       notes[i] = n[i];
    } 
  }

};


song allsongs[14];


void setup () {
  
  
 Serial.begin(1200);
 Serial.println("Setup ");
  
 pinMode(7, OUTPUT);

  byte dtmp0[] = {8, 8, 8, 8, 4, 4, 2, 2};
  int ntmp0[] = {NOTE_C3, NOTE_C4, NOTE_DS4, NOTE_G4, NOTE_C3, NOTE_AS2, NOTE_C3, NOTE_CS3};
  allsongs[0].init(dtmp0, ntmp0, 8);  
  
  byte dtmp1[] = {8, 8, 8, 8, 8, 8, 8, 8, 4, 4, 2 };
  int ntmp1[] = {NOTE_G4, NOTE_C5, NOTE_D5, NOTE_G5, NOTE_G4, NOTE_A4, NOTE_C5, NOTE_E5, NOTE_G4, NOTE_A4, NOTE_B4};
  allsongs[1].init(dtmp1, ntmp1, 11); 
  
  //b-day phrase1
  byte dtmp2[] = {8, 8, 4, 4, 4, 2};
  int ntmp2[] = {NOTE_C4, NOTE_C4, NOTE_D4, NOTE_C4, NOTE_F4, NOTE_E4};
  allsongs[2].init(dtmp2, ntmp2, 6); 
  
  byte dtmp3[] = {8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8 };
  int ntmp3[] = {NOTE_B3, NOTE_D4, NOTE_G3, NOTE_D4, NOTE_G4, NOTE_G3, NOTE_D4, NOTE_G4, NOTE_B3, NOTE_D4, NOTE_G3, NOTE_D4, NOTE_G4, NOTE_G3, NOTE_D4, NOTE_G4 };
  allsongs[3].init(dtmp3, ntmp3, 16);
  
  byte dtmp4[] = {8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8 };
  int ntmp4[] = {NOTE_C4, NOTE_E4, NOTE_G4, NOTE_A4, NOTE_AS4, NOTE_A4, NOTE_G4, NOTE_E4, NOTE_C4, NOTE_E4, NOTE_G4, NOTE_A4, NOTE_AS4, NOTE_A4, NOTE_G4, NOTE_E4};
  allsongs[4].init(dtmp4, ntmp4, 16);
  
  //b-day phrase2
  byte dtmp5[] = {8, 8, 4, 4, 4, 2 };
  int ntmp5[] = {NOTE_C4, NOTE_C4, NOTE_D4, NOTE_C4, NOTE_G4, NOTE_F4 };
  allsongs[5].init(dtmp5, ntmp5, 6);
  
   //b-day phrase3
  byte dtmp6[] = {8, 8, 4, 4, 4, 2, 2 };
  int ntmp6[] = {NOTE_C4, NOTE_C4, NOTE_C5, NOTE_A4, NOTE_F4, NOTE_E4, NOTE_D4 };
  allsongs[6].init(dtmp6, ntmp6, 7);
  
//bach melody1
  byte dtmp7[] = {8, 8, 4, 4, 4, 8, 8, 4, 4, 4 };
  int ntmp7[] = {NOTE_C5, NOTE_B4, NOTE_C5, NOTE_G4, NOTE_GS4, NOTE_C5, NOTE_B4, NOTE_C5, NOTE_D5, NOTE_G4 };
  allsongs[7].init(dtmp7, ntmp7, 10);
  
 //bach melody2
  byte dtmp8[] = {8, 8, 4, 8, 8, 4, 8, 8, 2 };
  int ntmp8[] = {NOTE_C5, NOTE_B4, NOTE_C5, NOTE_F4, NOTE_G4, NOTE_GS4, NOTE_G4, NOTE_F4, NOTE_DS4 };
  allsongs[8].init(dtmp8, ntmp8, 9);
  
  byte dtmp9[] = {8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8 };
  int ntmp9[] = {NOTE_F4, NOTE_A4, NOTE_C5, NOTE_D5, NOTE_DS5, NOTE_D5, NOTE_C5, NOTE_A4, NOTE_F4, NOTE_A4, NOTE_C5, NOTE_D5, NOTE_DS5, NOTE_D5, NOTE_C5, NOTE_A4 };
  allsongs[9].init(dtmp9, ntmp9, 16);
  
  byte dtmp10[] = {8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8 };
  int ntmp10[] = {NOTE_G4, NOTE_B4, NOTE_D5, NOTE_E5, NOTE_F5, NOTE_E5, NOTE_D5, NOTE_B4, NOTE_F4, NOTE_A4, NOTE_C5, NOTE_D5, NOTE_DS5, NOTE_D5, NOTE_C5, NOTE_A4 };
  allsongs[10].init(dtmp10, ntmp10, 16);
  
  byte dtmp11[] = {8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8 };
  int ntmp11[] = {NOTE_C4, NOTE_D4, NOTE_F4, NOTE_A4, NOTE_D5, NOTE_F4, NOTE_A4, NOTE_D5, NOTE_C4, NOTE_D4, NOTE_F4, NOTE_A4, NOTE_D5, NOTE_F4, NOTE_A4, NOTE_D5 };
  allsongs[11].init(dtmp11, ntmp11, 16);
  
  byte dtmp12[] = {8, 8, 4, 4, 4, 2 };
  int ntmp12[] = {NOTE_AS4, NOTE_AS4, NOTE_A4, NOTE_F4, NOTE_G4, NOTE_F4};
  allsongs[12].init(dtmp12, ntmp12, 6);
 
  byte dtmp13[] = {8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8 };
  int ntmp13[] = {NOTE_C4, NOTE_E4, NOTE_G4, NOTE_C5, NOTE_E5, NOTE_G4, NOTE_C5, NOTE_E5, NOTE_C4, NOTE_E4, NOTE_G4, NOTE_C5, NOTE_E5, NOTE_G4, NOTE_C5, NOTE_E5 };
  allsongs[13].init(dtmp13, ntmp13, 16);


 
  

}




void playTone (int pin, song &s) {

  for (int thisTone = 0; thisTone < s.numNotes; thisTone++) {
                  //to calculate the note duration, take one second
         // divided by the note  type.
         //e.g. quarter note = 1000/ 4, eighth note = 1000/8, etc.
         int noteDuration = 1000 / s.durations[thisTone];
         //delay(1000);
         tone (pin, s.notes[thisTone], noteDuration);
         
         //to distinguish the notes, set a minium time between them.
         //the note's duraion  + 20 % seems to work well:
         int pauseBetweenNotes = noteDuration * 1.30;
         delay(pauseBetweenNotes);
         
    }
}
/*

void printBit (int pin, int x) {
  Serial.print(pin);
  if (x == HIGH) {
     Serial.println(" = ON");
  } else {
     Serial.println(" = OFF");
  }  
}
*/

void loop(){
  int base1 = 0;
  int base2 = 0;
  int base3 = 0;
  int base4 = 0;
  
  val1=digitalRead(13);
  val2=digitalRead(12);
  val3=digitalRead(11);  
  val4=digitalRead(10);
  val5=digitalRead(9);
  val6=digitalRead(8);
  val7=digitalRead(7);
  val8=digitalRead(6);
  val9=digitalRead(5);
  val10=digitalRead(4);
  val11=digitalRead(3);
  val12=digitalRead(2);


 //base1 reading
  Serial.print("val1 = ");
  Serial.println(val1);
  Serial.println();
  Serial.print("val2 = ");  
  Serial.println(val2);
  Serial.println();  
  Serial.print("val3 = ");  
  Serial.println(val3);
  Serial.println();
  Serial.println("--------------");

/*
//base2 reading
  Serial.print("val4 = ");
  Serial.println(val4);
  Serial.println();
  Serial.print("val5 = ");  
  Serial.println(val5);
  Serial.println();  
  Serial.print("val6 = ");  
  Serial.println(val6);
  Serial.println();
  Serial.println("--------------");
  */
 

  //BASE1
  if (val1 == HIGH && val2 == LOW &&  val3 == LOW ) {
    playTone(7, allsongs[0]);

  } else if (val1==LOW && val2==HIGH &&  val3==LOW ) {
    playTone(7, allsongs[1]);

  } else if (val1==LOW && val2==LOW &&  val3==HIGH ) {
    playTone(7, allsongs[2]);
  	
  }else if (val1==HIGH && val2==HIGH &&  val3==LOW ) {
    playTone(7, allsongs[3]);
  	
  }else if (val1==HIGH && val2==LOW &&  val3==HIGH ) {
    playTone(7, allsongs[4]);
  	
  }else if (val1==LOW && val2==HIGH &&  val3==HIGH ) {
    playTone(7, allsongs[5]);
  	
  }else if (val1==HIGH && val2==HIGH &&  val3==HIGH ) {
    playTone(7, allsongs[6]);
  	
  }
  
  
  //Base2
  if (val4 == HIGH && val5 == LOW &&  val6 == LOW ) {
    playTone(7, allsongs[7]);

  } else if (val4==LOW && val5==HIGH &&  val6==LOW ) {
    playTone(7, allsongs[8]);

  } else if (val4==LOW && val5==LOW &&  val6==HIGH ) {
    playTone(7, allsongs[9]);
  	
  }else if (val4==HIGH && val5==HIGH &&  val6==LOW ) {
    playTone(7, allsongs[10]);
  	
  }else if (val4==HIGH && val5==LOW &&  val6==HIGH ) {
    playTone(7, allsongs[11]);
  	
  }else if (val4==LOW && val5==HIGH &&  val6==HIGH ) {
    playTone(7, allsongs[12]);
  	
  }else if (val4==HIGH && val5==HIGH &&  val6==HIGH ) {
    playTone(7, allsongs[12]);
    
  	
  }


}
